;(function() {
	if (window.WebViewJavascriptBridge) { return }

	var messageHandlers = {};
	var responseCallbacks = {};
	var uniqueId = 1;

	function init(messageHandler) {
		if (WebViewJavascriptBridge._messageHandler) { throw new Error('WebViewJavascriptBridge.init called twice') }
		WebViewJavascriptBridge._messageHandler = messageHandler
	}

	function send(data, responseCallback) {
		_doSend({ data:data }, responseCallback)
	}

	function registerHandler(handlerName, handler) {
		messageHandlers[handlerName] = handler
	}

	function callHandler(handlerName, data) {
		if (typeof data === 'object') {
			data = JSON.stringify(data);
		}
		_doSend({ handlerName:handlerName, data:data }, null)
	}

	function callHandler(handlerName, data, responseCallback) {
		if (typeof data === 'object') {
			data = JSON.stringify(data);
		}
		_doSend({ handlerName:handlerName, data:data }, responseCallback)
	}

	function _doSend(message, responseCallback) {
		console.log(message+" responseCallback:"+responseCallback);
		if (responseCallback) {
			var callbackId = 'cb_'+(uniqueId++)+'_'+new Date().getTime();
			responseCallbacks[callbackId] = responseCallback;
			message['callbackId'] = callbackId;
		}
		console.log("sending:"+JSON.stringify(message));
		_WebViewJavascriptBridge.handleMessageFromJs(message.data||null,message.callbackId||null,
				message.handlerName||null);
	}

	function _doResponse(message) {

		console.log("response:"+JSON.stringify(message));
		_WebViewJavascriptBridge.handleResponseFromJs(message.responseId||null, message.responseData||null);
	}

	function _dispatchMessageFromJava(messageJSON) {
			var message = JSON.parse(messageJSON);
			var messageHandler;
			console.log("_dispatchMessageFromJava:"+JSON.stringify(message));

			if (message.responseId) {
				var responseCallback = responseCallbacks[message.responseId];
                if (!responseCallback) {

                	console.log("_dispatchMessageFromJava: responseCallback is null");
                	return;
                }
                responseCallback(message.responseData);
                delete responseCallbacks[message.responseId];
			} else {
				var responseCallback;
				if (message.callbackId) {
					var callbackResponseId = message.callbackId;
					responseCallback = function(responseData) {
						_doResponse({ responseId:callbackResponseId, responseData:responseData });
					}
				}

				var handler = WebViewJavascriptBridge._messageHandler;
				if (message.handlerName) {
					handler = messageHandlers[message.handlerName];
				}
				try {
					handler(message.data, responseCallback);
				} catch(exception) {
					if (typeof console != 'undefined') {
						console.log("WebViewJavascriptBridge: WARNING: javascript handler threw.", message, exception);
					}
				}
			}
	}

	function _handleMessageFromJava(messageJSON) {
		_dispatchMessageFromJava(messageJSON)
	}

	window.WebViewJavascriptBridge = {
		init: init,
		send: send,
		registerHandler: registerHandler,
		callHandler: callHandler,
		_handleMessageFromJava: _handleMessageFromJava
	};

	var doc = document;
	var readyEvent = doc.createEvent('Events');
	readyEvent.initEvent('WebViewJavascriptBridgeReady');
	readyEvent.bridge = WebViewJavascriptBridge;
	doc.dispatchEvent(readyEvent);

	if(location.host === 'mp.weixin.qq.com') {

		WebViewJavascriptBridge.init();
		var sharedata = JSON.stringify({title : msg_title, desc : msg_desc, icon :msg_cdn_url, url : msg_link.replace(/&amp;/g, '&')});
		_WebViewJavascriptBridge.handleMessageFromJs(sharedata, null, 'shareable');
	}
})();
